/***********************************************
 *
 * OG Script Dumper v2.6 by learn_more
 * File: out\a183\script\cam_dump.as
 * Generated: 25-Jun-2012 19:01:43
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3b6b80 (0x7b6b80)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc19f0 (0x4c19f0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc1a20 (0x4c1a20)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b7000 (0x7b7000)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3b7740 (0x7b7740)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b74d0 (0x7b74d0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b73c0 (0x7b73c0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3b77a0 (0x7b77a0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3b7290 (0x7b7290)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b6fb0 (0x7b6fb0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3b7770 (0x7b7770)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3b7030 (0x7b7030)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3b7160 (0x7b7160)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3b6bd0 (0x7b6bd0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3b66a0 (0x7b66a0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x24d6a0 (0x64d6a0)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x24c520 (0x64c520)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x24c580 (0x64c580)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x24d4b0 (0x64d4b0)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x24d520 (0x64d520)
	void Update();		// 'Overgrowth.exe' + 0x251560 (0x651560)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2abe30 (0x6abe30)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2abde0 (0x6abde0)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x37d7e0 (0x77d7e0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x37d640 (0x77d640)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x37d5d0 (0x77d5d0)
	float GetLens();		// 'Overgrowth.exe' + 0x37d620 (0x77d620)
	void Update();		// 'Overgrowth.exe' + 0x37dc60 (0x77dc60)
	bool valid();		// 'Overgrowth.exe' + 0x37bba0 (0x77bba0)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x1836db18
SphereCollision sphere_col;		// 0x1836db1c
GUI gui;		// 0x1af1e1e8
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x436118 (0x836118)
CameraObject co;		// 0x1cf8fc00
CameraAnimationReader camera_animation_reader;		// 0x1cf8fcec
